declare type Nullable<T> = T | null;
interface LinkedNode<T> {
    node: T;
    next: any;
}
interface List<T> {
    isEmpty(): boolean;
    createNode(node: T): LinkedNode<T>;
    push(node: T): number;
    toString(): string;
    insert(node: T, index: number): boolean;
    get(index: number): Nullable<T>;
    getNodeAt(index: number): Nullable<LinkedNode<T>>;
    remove(index: number): Nullable<T>;
    indexOf(predicate: T): number;
    constains(predicate: T): boolean;
    getSize(): number;
    traverse(): Iterator<Nullable<T>>;
    reset(): boolean;
}
export default class LinkedList<T> implements List<T> {
    private size;
    private head;
    isEmpty(): boolean;
    createNode(node: T): LinkedNode<T>;
    push(node: T): number;
    insert(node: T, index?: number): boolean;
    getSize(): number;
    reset(): boolean;
    getNodeAt(index: number): Nullable<LinkedNode<T>>;
    get(index: number): Nullable<T>;
    remove(index: number): Nullable<T>;
    indexOf(predicate: T): number;
    constains(predicate: T): boolean;
    toString(): string;
    traverse(): Generator<Nullable<T>, void, unknown>;
}
export {};
