"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LinkedList {
    constructor() {
        this.size = 0;
        this.head = null;
    }
    isEmpty() {
        return this.size === 0;
    }
    createNode(node) {
        return {
            node,
            next: null
        };
    }
    push(node) {
        const newNode = this.createNode(node);
        if (this.head === null) {
            this.head = newNode;
        }
        else {
            let current = this.getNodeAt(this.size - 1);
            current.next = newNode;
        }
        this.size += 1;
        return this.size;
    }
    insert(node, index = 0) {
        if (index < 0 || index > this.size)
            return false;
        const newNode = this.createNode(node);
        if (index === 0) {
            newNode.next = this.head;
            this.head = newNode;
        }
        else {
            let previousHead = this.getNodeAt(index - 1);
            newNode.next = previousHead === null || previousHead === void 0 ? void 0 : previousHead.next;
            previousHead.next = newNode;
        }
        this.size += 1;
        return true;
    }
    getSize() {
        return this.size;
    }
    reset() {
        this.head = null;
        this.size = 0;
        return this.size === 0 && this.head === null;
    }
    getNodeAt(index) {
        if (index === undefined || index < 0 || index > this.size) {
            return null;
        }
        ;
        if (index === 0) {
            return this.head;
        }
        let current = this.head;
        for (let i = 0; i < index; i++) {
            current = current.next;
        }
        return current;
    }
    get(index) {
        const node = this.getNodeAt(index);
        return node ? node.node : null;
    }
    remove(index) {
        var _a;
        if (index < 0 || index > this.size) {
            return null;
        }
        let removedNode = this.head;
        if (index === 0) {
            this.head = (_a = this.head) === null || _a === void 0 ? void 0 : _a.next;
        }
        else {
            let previousNode = this.getNodeAt(index - 1);
            removedNode = previousNode === null || previousNode === void 0 ? void 0 : previousNode.next;
            previousNode.next = removedNode === null || removedNode === void 0 ? void 0 : removedNode.next;
        }
        this.size -= 1;
        return removedNode.node;
    }
    indexOf(predicate) {
        let current = this.head;
        if ((current === null || current === void 0 ? void 0 : current.node) === predicate) {
            return 0;
        }
        for (let i = 0; i < this.size; i++) {
            if ((current === null || current === void 0 ? void 0 : current.node) === predicate) {
                return i;
            }
            current = current === null || current === void 0 ? void 0 : current.next;
        }
        return -1;
    }
    constains(predicate) {
        return this.indexOf(predicate) !== -1;
    }
    toString() {
        var _a;
        if (!this.size)
            return '';
        let str = `${(_a = this.head) === null || _a === void 0 ? void 0 : _a.node}`;
        let current = this.head;
        for (let i = 0; i < this.size - 1; i++) {
            current = current === null || current === void 0 ? void 0 : current.next;
            str += `,${current === null || current === void 0 ? void 0 : current.node}`;
        }
        return str;
    }
    *traverse() {
        for (let i = 0; i < this.size; i++) {
            yield this.get(i);
        }
    }
}
exports.default = LinkedList;
